IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc
.686
.xmm

    atou      PROTO :DWORD
    atou_ex   PROTO :DWORD
    atodL     PROTO :DWORD
    atodJJ    PROTO :DWORD
    Axa2l     PROTO :DWORD
    atou_rock PROTO :DWORD

    ncnt equ <0>                    ; padding count
    padd equ <db 0>

    dalg equ <16>                   ; change data alignment here
    palg equ <16>                   ; change data pointer alignment here

    icnt equ <10000000>             ; iteration count

  ; ---------------------------
  ; set processor core (1 to 4)
  ; ---------------------------
    Core MACRO corenum
      mov eax, 1
      .if eax == 1
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000001b
      .elseif eax == 2
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000010b
      .elseif eax == 3
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000000100b
      .elseif eax == 4
        invoke SetProcessAffinityMask,rv(GetCurrentProcess), 00000000000000000000000000001000b
      .else
        xor ecx, ecx
      .endif
    ENDM
  ; ---------------------------


    .data
      align dalg
      itm1 db "4294967295",0
      align dalg
      itm2 db "3948593",0
      align dalg
      itm3 db "293",0
      align dalg
      itm4 db "0",0

      align palg
      item1 dd itm1
      align palg
      item2 dd itm2
      align palg
      item3 dd itm3
      align palg
      item4 dd itm4

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL tmr1 :DWORD
    LOCAL tmr2 :DWORD
    LOCAL tmr3 :DWORD
    LOCAL tmr4 :DWORD
    LOCAL tmr5 :DWORD
    LOCAL tmr6 :DWORD


    mov tmr1, 0
    mov tmr2, 0
    mov tmr3, 0
    mov tmr4, 0
    mov tmr5, 0
    mov tmr6, 0


    push ebx
    push esi
    push edi

  ; -----------------------------
  ; set the processor core to use
  ; -----------------------------
    Core 1    

 ;     invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS
 ;     invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_HIGHEST

  ; ------------------
  ; run each algo once
  ; ------------------
 ;     invoke atou,item1
 ;     invoke atodL,item1
 ;     invoke atodJJ,item1
 ;     invoke atou_ex,item1
 ;     invoke Axa2l,item1

    invoke SleepEx,1000,0
    rdtsc

    mov edi, 4

  tloop:

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atou,item1
    invoke atou,item2
    invoke atou,item3
    invoke atou,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr1, eax

    print ustr$(eax)," atou",13,10

    invoke SleepEx,1000,0

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atodL,item1
    invoke atodL,item2
    invoke atodL,item3
    invoke atodL,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr2, eax

    print ustr$(eax)," atodL",13,10

    invoke SleepEx,1000,0

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke Axa2l,item1
    invoke Axa2l,item2
    invoke Axa2l,item3
    invoke Axa2l,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr5, eax

    print ustr$(eax)," Axa2l",13,10

    invoke SleepEx,1000,0

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atodJJ,item1
    invoke atodJJ,item2
    invoke atodJJ,item3
    invoke atodJJ,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr3, eax

    print ustr$(eax)," atodJJ",13,10

    invoke SleepEx,1000,0

  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atou_ex,item1
    invoke atou_ex,item2
    invoke atou_ex,item3
    invoke atou_ex,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr4, eax

    print ustr$(eax)," atou_ex",13,10

    invoke SleepEx,1000,0

  ; ==============================
  ; ==============================

    invoke GetTickCount
    push eax

    rdtsc
    mov esi, icnt

    align 4
  @@:
    invoke atou_rock,item1
    invoke atou_rock,item2
    invoke atou_rock,item3
    invoke atou_rock,item4
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add tmr6, eax

    print ustr$(eax)," atou_rock",13,10

    invoke SleepEx,1000,0

















    sub edi, 1
    jnz tloop

    shr tmr1, 2
    shr tmr2, 2
    shr tmr3, 2
    shr tmr4, 2
    shr tmr5, 2
    shr tmr6, 2


    print chr$(13,10,13,10)

    print ustr$(tmr1)," ms average atou",13,10
    print ustr$(tmr2)," ms average atodL",13,10
    print ustr$(tmr3)," ms average atodJJ",13,10
    print ustr$(tmr4)," ms average atou_ex",13,10
    print ustr$(tmr5)," ms average Axa2l",13,10
    print ustr$(tmr6)," ms average atou_rock",13,10


 ;     invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_NORMAL
 ;     invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    REPEAT ncnt
      padd
    ENDM

align 16

atou proc String:DWORD

  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------
    mov edx, [esp+4]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit
    xor ecx, ecx

  lpst:
    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jnz lpst

  quit:
    lea eax, [ecx]

    ret 4

atou endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

 ; OPTION PROLOGUE:NONE
 ; OPTION EPILOGUE:NONE
 ; 
 ;     REPEAT ncnt
 ;       padd
 ;     ENDM
 ; 
 ; align 16
 ; 
 ; atou proc String:DWORD
 ; 
 ;   ; ------------------------------------------------
 ;   ; Convert decimal string into UNSIGNED DWORD value
 ;   ; ------------------------------------------------
 ; 
 ;     mov edx, [esp+4]
 ;     xor ecx, ecx
 ;     movzx eax, BYTE PTR [edx]
 ;     test eax, eax
 ;     jz quit
 ; 
 ;   lpst:
 ;     add edx, 1
 ;     lea ecx, [ecx+ecx*4]            ; mul ecx * 5
 ;     lea ecx, [eax+ecx*2-48]
 ;     movzx eax, BYTE PTR [edx]
 ;     test eax, eax
 ;     jz quit
 ; 
 ;     add edx, 1
 ;     lea ecx, [ecx+ecx*4]            ; mul ecx * 5
 ;     lea ecx, [eax+ecx*2-48]
 ;     movzx eax, BYTE PTR [edx]
 ;     test eax, eax
 ;     jnz lpst
 ; 
 ;   quit:
 ;     lea eax, [ecx]
 ; 
 ;     ret 4
 ; 
 ; atou endp
 ; 
 ; OPTION PROLOGUE:PrologueDef
 ; OPTION EPILOGUE:EpilogueDef

; 

    REPEAT ncnt
      padd
    ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

atodL proc String:DWORD
	pop			eax
	pop			edx
	push		eax
    movzx		ecx, byte ptr [edx]
    xor			eax, eax
    test			ecx, ecx
    jz				quitL
@@:
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
     add			cl,  byte ptr [edx+1]
     jz			quitL
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+2]
     jz			quitL 
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+3]
     jz			quitL 
    lea			eax, [eax+eax*4]
	add			edx, 4	
    lea			eax, [ecx+eax*2-30h]
	xor			ecx, ecx
    add			cl,  byte ptr [edx]
    jnz			@b
 quitL:
	ret
atodL   endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    REPEAT ncnt
      padd
    ENDM

align 16

    nop
    nop

Axa2l proc lpszStr:DWORD

    mov edx,[esp+4]

        xor eax,eax
        movzx ecx,byte ptr [edx]

        add ecx,-30h
        js @done

      @mainloop:
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx]
        movzx ecx,byte ptr [edx+1]
        add edx,1
        add ecx,-30h
        js @done

        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx]
        movzx ecx,byte ptr [edx+1]
        add edx,1
        add ecx,-30h
        jns @mainloop

      @done:       

    ret 4
Axa2l endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

    REPEAT ncnt
      padd
    ENDM

align 16

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

atodJJ proc String:DWORD
    
    mov edx, [esp+4]
    xor eax, eax
  @@:
    movzx ecx, byte ptr [edx]
    add edx, 1
    lea eax, [eax+eax*4]
    cmp byte ptr [edx], ch
    lea eax, [ecx+eax*2-30h]
    jz quit
    
    movzx ecx, byte ptr [edx]
    add edx, 1
    lea eax, [eax+eax*4]
    cmp byte ptr [edx], ch
    lea eax, [ecx+eax*2-30h]
    jnz @b
    
  quit:
    ret 4
    
atodJJ   endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    REPEAT ncnt
      padd
    ENDM

align 16

atou_ex proc String:DWORD

  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------

    mov edx, [esp+4]

    xor ecx, ecx
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+1]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+2]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+3]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+4]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+5]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+6]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+7]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+8]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+9]
    test eax, eax
    jz quit

    lea ecx, [ecx+ecx*4]
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx+10]
    test eax, eax
    jnz out_of_range

  quit:
    lea eax, [ecx]      ; return value in EAX
    or ecx, -1          ; non zero in ECX for success
    ret 4

  out_of_range:
    xor eax, eax        ; zero return value on error
    xor ecx, ecx        ; zero in ECX is out of range error
    ret 4

atou_ex endp

align 16
atou_rock proc String:DWORD

    mov ecx, [esp + 4]
    push ebx

    ; ---

    movzx eax, byte ptr [ecx + 0]
    test eax, eax
    jz @@done

    sub eax, 48

    movzx edx, byte ptr [ecx + 1]
    test edx, edx
    jz @@done

    movzx ebx, byte ptr [ecx + 2]
    lea eax, [4*eax + eax]			
    test ebx, ebx
    lea eax, [2*eax + edx - 48]
    jz @@done

    movzx edx, byte ptr [ecx + 3]
    lea eax, [4*eax + eax]			
    test edx, edx
    lea eax, [2*eax + ebx - 48]
    jz @@done

    movzx ebx, byte ptr [ecx + 4]
    lea eax, [4*eax + eax]			
    test ebx, ebx
    lea eax, [2*eax + edx - 48]
    jz @@done

    movzx edx, byte ptr [ecx + 5]
    lea eax, [4*eax + eax]			
    test edx, edx
    lea eax, [2*eax + ebx - 48]
    jz @@done

    movzx ebx, byte ptr [ecx + 6]
    lea eax, [4*eax + eax]			
    test ebx, ebx
    lea eax, [2*eax + edx - 48]
    jz @@done

    movzx edx, byte ptr [ecx + 7]
    lea eax, [4*eax + eax]			
    test edx, edx
    lea eax, [2*eax + ebx - 48]
    jz @@done

    movzx ebx, byte ptr [ecx + 8]
    lea eax, [4*eax + eax]			
    test ebx, ebx
    lea eax, [2*eax + edx - 48]
    jz @@done

    movzx edx, byte ptr [ecx + 9]
    lea eax, [4*eax + eax]			
    test edx, edx
    lea eax, [2*eax + ebx - 48]
    jz @@done

    lea eax, [4*eax + eax]
    lea eax, [2*eax + edx - 48]

@@done:
    pop ebx
    ret 4

atou_rock endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

    REPEAT ncnt
      padd
    ENDM

end start
